BasicLabelUI (Java Platform SE 8 )
Keywords: javax.swing.plaf.basic.BasicLabelUI class
Date: 2015-11-18

javax.swing.plaf.basic

## Class BasicLabelUI

- java.lang.Object
- - javax.swing.plaf.ComponentUI
  - - javax.swing.plaf.LabelUI
    - - javax.swing.plaf.basic.BasicLabelUI

- All Implemented Interfaces:
    PropertyChangeListener, EventListener
  Direct Known Subclasses:
    MetalLabelUI, SynthLabelUI

      public class BasicLabelUI
      extends LabelUI
      implements PropertyChangeListener

  A Windows L&F implementation of LabelUI. This implementation is completely static, i.e. there's only one UIView implementation that's shared by all JLabel objects.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static BasicLabelUI` | `labelUI` The default `BasicLabelUI` instance.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BasicLabelUI()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static ComponentUI` | `createUI(JComponent c)`
    `int` | `getBaseline(JComponent c, int width, int height)` Returns the baseline.
    `Component.BaselineResizeBehavior` | `getBaselineResizeBehavior(JComponent c)` Returns an enum indicating how the baseline of the component changes as the size changes.
    `Dimension` | `getMaximumSize(JComponent c)` Returns the specified component's maximum size appropriate for the look and feel.
    `Dimension` | `getMinimumSize(JComponent c)` Returns the specified component's minimum size appropriate for the look and feel.
    `Dimension` | `getPreferredSize(JComponent c)` Returns the specified component's preferred size appropriate for the look and feel.
    `protected void` | `installComponents(JLabel c)`
    `protected void` | `installDefaults(JLabel c)`
    `protected void` | `installKeyboardActions(JLabel l)`
    `protected void` | `installListeners(JLabel c)`
    `void` | `installUI(JComponent c)` Configures the specified component appropriately for the look and feel.
    `protected String` | `layoutCL(JLabel label, FontMetrics fontMetrics, String text, Icon icon, Rectangle viewR, Rectangle iconR, Rectangle textR)` Forwards the call to SwingUtilities.layoutCompoundLabel().
    `void` | `paint(Graphics g, JComponent c)` Paints the label text with the foreground color, if the label is opaque then paints the entire background with the background color.
    `protected void` | `paintDisabledText(JLabel l, Graphics g, String s, int textX, int textY)` Paint clippedText at textX, textY with background.lighter() and then shifted down and to the right by one pixel with background.darker().
    `protected void` | `paintEnabledText(JLabel l, Graphics g, String s, int textX, int textY)` Paint clippedText at textX, textY with the labels foreground color.
    `void` | `propertyChange(PropertyChangeEvent e)` This method gets called when a bound property is changed.
    `protected void` | `uninstallComponents(JLabel c)`
    `protected void` | `uninstallDefaults(JLabel c)`
    `protected void` | `uninstallKeyboardActions(JLabel c)`
    `protected void` | `uninstallListeners(JLabel c)`
    `void` | `uninstallUI(JComponent c)` Reverses configuration which was done on the specified component during `installUI`.

    - ### Methods inherited from class javax.swing.plaf.ComponentUI

      `contains, getAccessibleChild, getAccessibleChildrenCount, update`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### labelUI

          protected static BasicLabelUI labelUI

      The default `BasicLabelUI` instance. This field might not be used. To change the default instance use a subclass which overrides the `createUI` method, and place that class name in defaults table under the key "LabelUI".

  - ### Constructor Detail

    - #### BasicLabelUI

          public BasicLabelUI()

  - ### Method Detail

    - #### layoutCL

          protected String layoutCL(JLabel label,
                                    FontMetrics fontMetrics,
                                    String text,
                                    Icon icon,
                                    Rectangle viewR,
                                    Rectangle iconR,
                                    Rectangle textR)

      Forwards the call to SwingUtilities.layoutCompoundLabel(). This method is here so that a subclass could do Label specific layout and to shorten the method name a little.
      See Also:
        `SwingUtilities.layoutCompoundLabel(javax.swing.JComponent, java.awt.FontMetrics, java.lang.String, javax.swing.Icon, int, int, int, int, java.awt.Rectangle, java.awt.Rectangle, java.awt.Rectangle, int)`

    - #### paintEnabledText

          protected void paintEnabledText(JLabel l,
                                          Graphics g,
                                          String s,
                                          int textX,
                                          int textY)

      Paint clippedText at textX, textY with the labels foreground color.
      See Also:
        `paint(java.awt.Graphics, javax.swing.JComponent)`, `paintDisabledText(javax.swing.JLabel, java.awt.Graphics, java.lang.String, int, int)`

    - #### paintDisabledText

          protected void paintDisabledText(JLabel l,
                                           Graphics g,
                                           String s,
                                           int textX,
                                           int textY)

      Paint clippedText at textX, textY with background.lighter() and then shifted down and to the right by one pixel with background.darker().
      See Also:
        `paint(java.awt.Graphics, javax.swing.JComponent)`, `paintEnabledText(javax.swing.JLabel, java.awt.Graphics, java.lang.String, int, int)`

    - #### paint

          public void paint(Graphics g,
                            JComponent c)

      Paints the label text with the foreground color, if the label is opaque then paints the entire background with the background color. The Label text is drawn by `paintEnabledText(javax.swing.JLabel, java.awt.Graphics, java.lang.String, int, int)` or `paintDisabledText(javax.swing.JLabel, java.awt.Graphics, java.lang.String, int, int)`. The locations of the label parts are computed by `layoutCL(javax.swing.JLabel, java.awt.FontMetrics, java.lang.String, javax.swing.Icon, java.awt.Rectangle, java.awt.Rectangle, java.awt.Rectangle)`.
      Overrides:
        `paint` in class `ComponentUI`
      Parameters:
        `g` - the `Graphics` context in which to paint
        `c` - the component being painted; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      See Also:
        `paintEnabledText(javax.swing.JLabel, java.awt.Graphics, java.lang.String, int, int)`, `paintDisabledText(javax.swing.JLabel, java.awt.Graphics, java.lang.String, int, int)`, `layoutCL(javax.swing.JLabel, java.awt.FontMetrics, java.lang.String, javax.swing.Icon, java.awt.Rectangle, java.awt.Rectangle, java.awt.Rectangle)`

    - #### getPreferredSize

          public Dimension getPreferredSize(JComponent c)

      Description copied from class: `ComponentUI`
      Returns the specified component's preferred size appropriate for the look and feel. If `null` is returned, the preferred size will be calculated by the component's layout manager instead (this is the preferred approach for any component with a specific layout manager installed). The default implementation of this method returns `null`.
      Overrides:
        `getPreferredSize` in class `ComponentUI`
      Parameters:
        `c` - the component whose preferred size is being queried; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      See Also:
        `JComponent.getPreferredSize()`, `LayoutManager.preferredLayoutSize(java.awt.Container)`

    - #### getMinimumSize

          public Dimension getMinimumSize(JComponent c)

      Description copied from class: `ComponentUI`
      Returns the specified component's minimum size appropriate for the look and feel. If `null` is returned, the minimum size will be calculated by the component's layout manager instead (this is the preferred approach for any component with a specific layout manager installed). The default implementation of this method invokes `getPreferredSize` and returns that value.
      Overrides:
        `getMinimumSize` in class `ComponentUI`
      Parameters:
        `c` - the component whose minimum size is being queried; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      Returns:
        getPreferredSize(c)
      See Also:
        `JComponent.getMinimumSize()`, `LayoutManager.minimumLayoutSize(java.awt.Container)`, `ComponentUI.getPreferredSize(javax.swing.JComponent)`

    - #### getMaximumSize

          public Dimension getMaximumSize(JComponent c)

      Description copied from class: `ComponentUI`
      Returns the specified component's maximum size appropriate for the look and feel. If `null` is returned, the maximum size will be calculated by the component's layout manager instead (this is the preferred approach for any component with a specific layout manager installed). The default implementation of this method invokes `getPreferredSize` and returns that value.
      Overrides:
        `getMaximumSize` in class `ComponentUI`
      Parameters:
        `c` - the component whose maximum size is being queried; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      Returns:
        getPreferredSize(c)
      See Also:
        `JComponent.getMaximumSize()`, `LayoutManager2.maximumLayoutSize(java.awt.Container)`

    - #### getBaseline

          public int getBaseline(JComponent c,
                                 int width,
                                 int height)

      Returns the baseline.
      Overrides:
        `getBaseline` in class `ComponentUI`
      Parameters:
        `c` - `JComponent` baseline is being requested for
        `width` - the width to get the baseline for
        `height` - the height to get the baseline for
      Returns:
        baseline or a value < 0 indicating there is no reasonable baseline
      Throws:
        `NullPointerException` - if `c` is `null`
        `IllegalArgumentException` - if width or height is < 0
      Since:
        1.6
      See Also:
        `JComponent.getBaseline(int, int)`

    - #### getBaselineResizeBehavior

          public Component.BaselineResizeBehavior getBaselineResizeBehavior(JComponent c)

      Returns an enum indicating how the baseline of the component changes as the size changes.
      Overrides:
        `getBaselineResizeBehavior` in class `ComponentUI`
      Parameters:
        `c` - `JComponent` to return baseline resize behavior for
      Returns:
        an enum indicating how the baseline changes as the component size changes
      Throws:
        `NullPointerException` - if `c` is `null`
      Since:
        1.6
      See Also:
        `JComponent.getBaseline(int, int)`

    - #### installUI

          public void installUI(JComponent c)

      Description copied from class: `ComponentUI`
      Configures the specified component appropriately for the look and feel. This method is invoked when the `ComponentUI` instance is being installed as the UI delegate on the specified component. This method should completely configure the component for the look and feel, including the following:
      1. Install default property values for color, fonts, borders, icons, opacity, etc. on the component. Whenever possible, property values initialized by the client program should not be overridden.
      2. Install a `LayoutManager` on the component if necessary.
      3. Create/add any required sub-components to the component.
      4. Create/install event listeners on the component.
      5. Create/install a `PropertyChangeListener` on the component in order to detect and respond to component property changes appropriately.
      6. Install keyboard UI (mnemonics, traversal, etc.) on the component.
      7. Initialize any appropriate instance data.
      Overrides:
        `installUI` in class `ComponentUI`
      Parameters:
        `c` - the component where this UI delegate is being installed
      See Also:
        `ComponentUI.uninstallUI(javax.swing.JComponent)`, `JComponent.setUI(javax.swing.plaf.ComponentUI)`, `JComponent.updateUI()`

    - #### uninstallUI

          public void uninstallUI(JComponent c)

      Description copied from class: `ComponentUI`
      Reverses configuration which was done on the specified component during `installUI`. This method is invoked when this `UIComponent` instance is being removed as the UI delegate for the specified component. This method should undo the configuration performed in `installUI`, being careful to leave the `JComponent` instance in a clean state (no extraneous listeners, look-and-feel-specific property objects, etc.). This should include the following:
      1. Remove any UI-set borders from the component.
      2. Remove any UI-set layout managers on the component.
      3. Remove any UI-added sub-components from the component.
      4. Remove any UI-added event/property listeners from the component.
      5. Remove any UI-installed keyboard UI from the component.
      6. Nullify any allocated instance data objects to allow for GC.
      Overrides:
        `uninstallUI` in class `ComponentUI`
      Parameters:
        `c` - the component from which this UI delegate is being removed; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      See Also:
        `ComponentUI.installUI(javax.swing.JComponent)`, `JComponent.updateUI()`

    - #### installDefaults

          protected void installDefaults(JLabel c)

    - #### installListeners

          protected void installListeners(JLabel c)

    - #### installComponents

          protected void installComponents(JLabel c)

    - #### installKeyboardActions

          protected void installKeyboardActions(JLabel l)

    - #### uninstallDefaults

          protected void uninstallDefaults(JLabel c)

    - #### uninstallListeners

          protected void uninstallListeners(JLabel c)

    - #### uninstallComponents

          protected void uninstallComponents(JLabel c)

    - #### uninstallKeyboardActions

          protected void uninstallKeyboardActions(JLabel c)

    - #### createUI

          public static ComponentUI createUI(JComponent c)

    - #### propertyChange

          public void propertyChange(PropertyChangeEvent e)

      Description copied from interface: `PropertyChangeListener`
      This method gets called when a bound property is changed.
      Specified by:
        `propertyChange` in interface `PropertyChangeListener`
      Parameters:
        `e` - A PropertyChangeEvent object describing the event source and the property that has changed.

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2015, Oracle and/or its affiliates. All rights reserved.